#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <malloc.h>
#include <io.h>
#include <conio.h>
#include <mem.h>


#define WRITE_DATA_SB   	0x10
#define ON_SOUND_SB		0xD1
#define OFF_SOUND_SB		0xD3
#define HALT_DMA_8		0xD0
#define TIME_CONSTANT 		0x40
#define DMA_8_BIT_DAC_LO	0x14
#define DMA_8_BIT_DAC_HI	0x91
#define SET_LEN_DMA_8_BIT	0x48


#define MAX_BASE_SB 5

#define lo(value) (unsigned char)((value) & 0x00FF)
#define hi(value) (unsigned char)((value) >> 8)


int     basesSB[MAX_BASE_SB]={ 0x220, 0x230, 0x240, 0x250, 0x260 };
int	baseAddrSB=0x220;
int	verSB=0;
char	SixteenBit=0, Stereo=0, MaxFrequency=0, Fifo=0;
char	DMAChannel=1, SbIRQ=5;
char * far data=0;
char * far aligned;
unsigned long aligned_physical;

static void far interrupt (*OldIRQ)();
volatile int DMA_complete;
int count=0;


	// 

unsigned char pascal ReadSB
	(void)
{
unsigned int value;

while (!(inp((baseAddrSB+0xE)) & 0x80));
value = inp((baseAddrSB+0xA));
return value;
}

	// ஢ 稥

char pascal CheckSB
	( void )
{
int i, j;
for ( j=0; j<MAX_BASE_SB; j++ )
{
baseAddrSB=basesSB[j];
outportb(baseAddrSB+6,1);
delay(10);
outportb(baseAddrSB+6,0);
delay(10);
for(i=0; i<30000; i++ )
	if ( ReadSB()==0xAA )
		return 1;
}
return 0;
}

	// 

void pascal WriteSB
	(unsigned char value)
{
while (inp(baseAddrSB+0xC) & 0x80);
outp(baseAddrSB+0xC, value);
}

	// 

int pascal VersionSB
	( void )
{
char ch, ch1;
WriteSB(0xE1);
ch=ReadSB();
ch1=ReadSB();
verSB=ch<<8 | ch1;
if ( verSB>=0x200 )
	Fifo=1;
if ( verSB>=0x201 )
	MaxFrequency=1;
if ( verSB>=0x300 )
	Stereo=1;
if ( verSB>=0x301 )
	SixteenBit=1;
return verSB;
}

	// ࠡ稪 뢠

static void far interrupt SBHandler( void )
{
enable();
DMA_complete = 1;
count++;

// ⢥
inportb(baseAddrSB+0xE);
outportb(0x20,0x20);
}

	// 樠

int	SetupSB
	( int irq, int dma )
{
static char init=0;
unsigned long physical;
unsigned char im, tm;

if ( init==1 ) return 0;
init=1;
if ( dma<0 || dma>3 )
	DMAChannel=1;
else	DMAChannel=dma;
if ( irq!=2 && irq!=3 && irq!=5 && irq!=7 )
	SbIRQ=5;
else	SbIRQ=irq;
if ( CheckSB()!=1 ) return 0;
VersionSB();
printf(" SB - %d.%02d\n",hi(verSB),lo(verSB));
data=(char far *)farmalloc(131000L);
if ( data==NULL )
{
	printf("    DMA\n");
	return 0;
}
physical=((unsigned long)FP_OFF(data))+(((unsigned long)FP_SEG(data))<<4);
aligned_physical=physical+0x0FFFFL;
aligned_physical&=0xF0000L;
aligned=MK_FP((unsigned )((aligned_physical >> 4) & 0xFFFF),0);

DMA_complete = 0;
disable();
OldIRQ = getvect(0x08 + SbIRQ);
setvect(0x08 + SbIRQ,SBHandler);
DMA_complete = 0;
im = inportb(0x21);
tm = ~(1 << SbIRQ);
outportb(0x21,im & tm);
enable();

WriteSB(ON_SOUND_SB);

return 1;
}

	//  SB

void	ResetSB
	( void )
{
unsigned char i;
inportb(baseAddrSB+0xE);
outportb(0x20,0x20);

if ( data ) farfree(data);
WriteSB(OFF_SOUND_SB);
WriteSB(HALT_DMA_8);

disable();
i = inportb(0x21);
outportb(0x21, i | (1 << SbIRQ));
setvect(0x08 + SbIRQ,OldIRQ);
enable();
}

	// ⠭ 

unsigned int pascal RateSB
	( unsigned int rate )
{
unsigned char tc;

if ( MaxFrequency==0 || rate<22528 )
{
    if ( rate<5000 ) rate=5000;
    if ( rate>22528 ) rate=22528;
    tc = (unsigned char)(256 - (1000000/rate));
    rate = (unsigned int)(1000000/(256-tc));
}
else
{
    if ( rate<5000 ) rate=5000;
    if ( rate>45056 ) rate=45056;
    tc = (unsigned char)(hi((unsigned int)(65536-(256000000L/rate))));
}
WriteSB(TIME_CONSTANT);
WriteSB(tc);
return rate;
}

	// ந뢠 롮ન

void pascal PlaySB
	( char far * raw, unsigned int len )
{
int MaskPort, ClrPort, ModePort, ModeDMA, CountPort, PagePort,
	BaseAddrPort;
int pageports[4]={ 0x87, 0x83, 0x81, 0x82 };

_fmemcpy(aligned,raw,len);

// ன ࠡ稪
DMA_complete=0;

// ன DMA
MaskPort=0x0A; ClrPort=0xC; ModePort=0xB;
ModeDMA=0x48+DMAChannel;
CountPort=1+DMAChannel*2;
BaseAddrPort=DMAChannel*2;
PagePort=pageports[DMAChannel];

outportb(MaskPort, 4 + DMAChannel);
outportb(ClrPort, DMAChannel );
outportb(ModePort, ModeDMA );
outportb(BaseAddrPort,lo(aligned_physical));
outportb(BaseAddrPort,hi(aligned_physical));
outportb(PagePort,(unsigned char)((aligned_physical>>16)&0xFF));
outportb(CountPort,lo(len-1));
outportb(CountPort,hi(len-1));
outportb(MaskPort, DMAChannel );

// ன DSP
if ( MaxFrequency==0 )
{
    WriteSB(DMA_8_BIT_DAC_LO);
    WriteSB(lo(len-1));
    WriteSB(hi(len-1));
}
else
{
    WriteSB(SET_LEN_DMA_8_BIT);
    WriteSB(lo(len-1));
    WriteSB(hi(len-1));
    WriteSB(DMA_8_BIT_DAC_HI);
}
//////////
}


unsigned int pascal DmaCount
         ( void )
{
unsigned int x;
x=inportb(0x03);
x|=inportb(0x03)<<8;
if(x==0xFFFF)
 inportb(baseAddrSB+0xE);
return(x);
}

	// ﭨ ந

char pascal StatePlaySB
	( void )
{
if ( DMA_complete==0 ) return 0;
//&& DmaCount()!=0xffff ) return 0;
else return 1;
}


void    main
	( int argc, char * argv[] )
{
unsigned int len, i, rate;
FILE * f;
char far * raw;

if ( argc<2 )
{
	printf("  䠩 롮ન\n");
	return;
}

if ( SetupSB(5,1)==1 )
	printf("S O U N D  B L A S T E R !!!!\n");
else {
	printf(", ,      ...\n");
	return;
	}

f = fopen(argv[1],"rb");
raw = ( char far * ) farmalloc(32000L);
if ( f == 0 || raw==0 )
{
	printf("   䠩 롮ન - %s\n",argv[1]);
	printf(" \n",argv[1]);
	ResetSB();
	return;
}

printf("ந 롮ન ...\n");
if ( argc>2 ) rate=RateSB(atoi(argv[2]));
else rate=RateSB(22000);
printf(" - %d\n",rate);

len=fread(raw,1,3200,f);
i=0;
while ( 1 )
{
	if ( len==0 ) break;
	PlaySB(raw,len);
	i++;
	printf("%04d,%06d\r",i,len);
	len=fread(raw,1,3200,f);
	while ( StatePlaySB()==0 )
		if ( kbhit() ) { getch(); goto Fin; }
}

Fin:
printf("\n%d\n",count);
if ( f!=0 ) fclose(f);
if ( raw!=0 ) farfree(raw);
ResetSB();

}

