#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <malloc.h>
#include <io.h>
#include <conio.h>
#include <mem.h>
#include <string.h>
#include <string.h>
#include <dir.h>
#include <ctype.h>

typedef struct {
	char id_riff[4];
        long len_riff;

	char id_chuck[4];
	char fmt[4];
	long len_chuck;

	int  type;
	int  channels;
	long freq;
	long bytes;
	int  align;
	int  bits;
} TitleWave;

typedef struct {
	char id_data[4];
	long len_data;
} TitleDataWave;

typedef struct {
	char txt_id[20]; // "Creative Voice File\x1A"
        unsigned int offset_data; // ᬥ饭 砫 ࢮ  
	unsigned int ver; //  ᨨ
	unsigned int id; // 䨪, ᫮ ୮  ᨨ 
		  //    1234h, .. (((~ver)+0x1234)&0xFFFF)==id
} VocHeader;

typedef struct {
	unsigned char type; // ⨯ 
	unsigned long len; //   (  㦭 ⮫쪮  3  )
} VocBlock;

typedef struct {
	unsigned char rate; //  ⨧樨,    40H
	unsigned char type_zip; // ᯮᮡ 㯠 0 -  㯠
} VocBlock1;

typedef struct {
        unsigned int time; // ६ 設
        unsigned char rate; //  ⨧樨,    40H
} VocBlock3;

unsigned int marker; // થ
unsigned int count_repeat; // ᫮ ஢  

typedef struct {
        unsigned int rate; //  ⨧樨,    40H
                            // : 65536 - (256000000/rate)
                            // ८: 65536 - (25600000/(2*rate))
        unsigned char pack; // ᯮᮡ 㯠 =0  㯠
        unsigned char mode; //  : 0 - , 1 - ८
} VocBlock8;

typedef struct
{
	int	port;
	char	irq;
	char	dma;
	int	ver;
} InitSB;

#define WRITE_DATA_SB   	0x10
#define ON_SOUND_SB		0xD1
#define OFF_SOUND_SB		0xD3
#define HALT_DMA_8		0xD0
#define TIME_CONSTANT 		0x40
#define DMA_8_BIT_DAC_LO	0x14
#define DMA_8_BIT_DAC_HI	0x91
#define SET_LEN_DMA_8_BIT	0x48

#define MONO	0
#define STEREO	1

#define USE_FILTER	0
#define BYPASS_FILTER	1

#define MAX_BASE_SB 5

#define lo(value) (unsigned char)((value) & 0x00FF)
#define hi(value) (unsigned char)((value) >> 8)


int     basesSB[MAX_BASE_SB]={ 0x220, 0x230, 0x240, 0x250, 0x260 };
int	baseAddrSB=0x220;
int	verSB=0;
char	SixteenBit=0, Stereo=0, MaxFrequency=0, Fifo=0;
char	DMAChannel=1, SbIRQ=7;

//char * far data=0;
//char * far aligned;
//unsigned long aligned_physical;


static void far interrupt (*OldIRQ)();
volatile int DMA_complete;
int count=0;

typedef struct
{
	char far * buf; //   
	char far * dma; //   buf  DMA
	unsigned int len; //   DMA
	unsigned long physical; // 䨧. 
	unsigned char lo_off; // 訩  ᬥ饭
	unsigned char hi_off; // 訩  ᬥ饭  DMA
	unsigned int page; // 64K ࠭
} DMA_Buf;


DMA_Buf dBuf;


int	dmaMalloc
	( DMA_Buf * dmb )	// 뤥    DMA
{
char * p;
unsigned int s, l;

  dmb->buf=(char far *)malloc(dmb->len);
  if ( dmb->buf==0 ) return 0;

  s=FP_SEG(dmb->buf); // ᥣ
  s&=0xfff; // ⮫쪮 64K
  l=(dmb->len)>>4;
  if ( s < ( 0x1000-l) ) // ஢ઠ  祭
	//  ᥪ
		dmb->dma=dmb->buf;
  else
	// ᥪ
	{
		if ( (0x1000-s)<(s+l-0x1000) )
		{
			//    ᫥ ࠭
			dmb->dma=(char far *)MK_FP(FP_SEG(dmb->buf)+(0x1000-s),0);
			dmb->len-=((0x1000-s)<<4)-FP_OFF(dmb->buf);
		}
		else
		{
			dmb->dma=dmb->buf;
			dmb->len=((0x1000-s)<<4)-FP_OFF(dmb->buf);
		}
	}
dmb->physical=((unsigned long)FP_OFF(dmb->dma))+
	(((unsigned long)FP_SEG(dmb->dma))<<4);
s=dmb->physical % 0x10000L;
dmb->lo_off=(unsigned char)(s & 0x00FF);
dmb->hi_off=(unsigned char)(s >> 8);
dmb->page=(unsigned char)((dmb->physical>>16)&0x00FF);
return 1;
}



void	dmaFree
	( DMA_Buf * dmb )
{
if ( dmb->buf==0 ) return;
free( dmb->buf );
dmb->buf=dmb->dma=0;
dmb->len=0;
}

	// 

unsigned char pascal ReadSB
	(void)
{
unsigned int value;

while (!(inp((baseAddrSB+0xE)) & 0x80));
value = inp((baseAddrSB+0xA));
return value;
}

	//   SB  㦥

int	sbEnvData
	( InitSB * isb )
{
char *t, *t1, *blaster;
isb->port=0x220; isb->irq=7; isb->dma=1; isb->ver=0x310;

t = getenv("BLASTER");

if ( t == NULL )
	return 0;

blaster = strdup(t);

t = strtok(blaster," \t");
while ( t )
{
	switch(toupper(t[0]))
	{
	    case 'A':
		isb->port = (int)strtol(t+1,&t1,16);
		break;
	    case 'I':
		isb->irq = atoi(t+1);
		break;
	    case 'D':
		isb->dma = atoi(t+1);
		break;
	    case 'T':
		isb->ver = atoi(t+1);
		break;
	    default:
		break;
	}
	t = strtok(NULL," \t");
    }
free(blaster);
return 1;
}


	// ஢ 稥

char pascal CheckSB
	( void )
{
int i, j;
for ( j=0; j<MAX_BASE_SB; j++ )
{
baseAddrSB=basesSB[j];
outportb(baseAddrSB+6,1);
delay(10);
outportb(baseAddrSB+6,0);
delay(10);
for(i=0; i<30000; i++ )
	if ( ReadSB()==0xAA )
		return 1;
}
return 0;
}

	// 

void pascal WriteSB
	(unsigned char value)
{
while (inp(baseAddrSB+0xC) & 0x80);
outp(baseAddrSB+0xC, value);
}

	// 

int pascal VersionSB
	( void )
{
char ch, ch1;
WriteSB(0xE1);
ch=ReadSB();
ch1=ReadSB();
verSB=ch<<8 | ch1;
if ( verSB>=0x200 )
	Fifo=1;
if ( verSB>=0x201 )
	MaxFrequency=1;
if ( verSB>=0x300 )
	Stereo=1;
if ( verSB>=0x301 )
	SixteenBit=1;
return verSB;
}

void	magWriteMixerSB
	( char index, char val )
{
outportb(baseAddrSB+4,index);
outportb(baseAddrSB+5,val);
}

void	magOutputMixerSB
	( char st, char filtr )
{
unsigned char val=0;
val=(st==1)?2:0;
val|=(filtr==1)?0x20:0;
magWriteMixerSB(0x0E,val);
}


void	magResetMixerSB
	( void )
{
magWriteMixerSB(0,0); // RESET
}


	// ࠡ稪 뢠

static void far interrupt SBHandler( void )
{
enable();
DMA_complete = 1;
count++;

// ⢥
inportb(baseAddrSB+0xE);
outportb(0x20,0x20);
}

	// 樠

int	SetupSB
	( int irq, int dma )
{
static char init=0;
unsigned long physical;
unsigned char im, tm;

if ( init==1 ) return 0;
init=1;
if ( dma<0 || dma>3 )
	DMAChannel=1;
else	DMAChannel=dma;
if ( irq!=2 && irq!=3 && irq!=5 && irq!=7 )
	SbIRQ=7;
else	SbIRQ=irq;
if ( CheckSB()!=1 ) return 0;
VersionSB();
printf(" SB - %d.%02d\n",hi(verSB),lo(verSB));
dBuf.len=40002;
if ( dmaMalloc(&dBuf)==0 )
{
	printf("    DMA\n");
	return 0;
}

DMA_complete = 0;
disable();
OldIRQ = getvect(0x08 + SbIRQ);
setvect(0x08 + SbIRQ,SBHandler);
DMA_complete = 0;
im = inportb(0x21);
tm = ~(1 << SbIRQ);
outportb(0x21,im & tm);
enable();

WriteSB(ON_SOUND_SB);
/*if ( verSB>0x300 )
{
	magResetMixerSB();
	magOutputMixerSB(BYPASS_FILTER,STEREO);
}
*/
magWriteMixerSB(0x0E,0x11);

return 1;
}

	//  SB

void	ResetSB
	( void )
{
unsigned char i;
inportb(baseAddrSB+0xE);
outportb(0x20,0x20);

dmaFree(&dBuf);
WriteSB(OFF_SOUND_SB);
WriteSB(HALT_DMA_8);

disable();
i = inportb(0x21);
outportb(0x21, i | (1 << SbIRQ));
setvect(0x08 + SbIRQ,OldIRQ);
enable();
}

	// ⠭ 

unsigned int pascal RateSB
	( unsigned int rate )
{
unsigned char tc;

if ( MaxFrequency==0 || rate<22528 )
{
    if ( rate<5000 ) rate=5000;
    if ( rate>22528 ) rate=22528;
    tc = (unsigned char)(256 - (1000000/rate));
    rate = (unsigned int)(1000000/(256-tc));
}
else
{
    if ( rate<5000 ) rate=5000;
    if ( rate>45056 ) rate=45056;
    tc = (unsigned char)(hi((unsigned int)(65536-(256000000L/rate))));
}
WriteSB(TIME_CONSTANT);
WriteSB(tc);
return rate;
}

	// ந뢠 롮ન

void pascal PlaySB
	( char far * raw, unsigned int len )
{
int MaskPort, ClrPort, ModePort, ModeDMA, CountPort, PagePort,
	BaseAddrPort;
int pageports[4]={ 0x87, 0x83, 0x81, 0x82 };

if ( len>dBuf.len ) return;

_fmemcpy(dBuf.dma,raw,len);

// ன ࠡ稪
DMA_complete=0;

// ன DMA
MaskPort=0x0A; ClrPort=0xC; ModePort=0xB;
ModeDMA=0x48+DMAChannel;
CountPort=1+DMAChannel*2;
BaseAddrPort=DMAChannel*2;
PagePort=pageports[DMAChannel];

outportb(MaskPort, 4 + DMAChannel);
outportb(ClrPort, DMAChannel );
outportb(ModePort, ModeDMA );
outportb(BaseAddrPort,dBuf.lo_off);
outportb(BaseAddrPort,dBuf.hi_off);
outportb(PagePort,dBuf.page);
outportb(CountPort,lo(len-1));
outportb(CountPort,hi(len-1));
outportb(MaskPort, DMAChannel );

// ன DSP
if ( MaxFrequency==0 )
{
    WriteSB(DMA_8_BIT_DAC_LO);
    WriteSB(lo(len-1));
    WriteSB(hi(len-1));
}
else
{
    WriteSB(SET_LEN_DMA_8_BIT);
    WriteSB(lo(len-1));
    WriteSB(hi(len-1));
    WriteSB(DMA_8_BIT_DAC_HI);
}
//////////
}


unsigned int pascal DmaCount
	 ( void )
{
unsigned int x;
x=inportb(0x03);
x|=inportb(0x03)<<8;
if(x==0xFFFF)
 inportb(baseAddrSB+0xE);
return(x);
}

	// ﭨ ந

char pascal StatePlaySB
	( void )
{
if ( DMA_complete==0 ) return 0;
//&& DmaCount()!=0xffff ) return 0;
else return 1;
}


int	playFile
	( FILE * f, unsigned int rate, char far * raw, unsigned int len,
	  unsigned long len_data )
{
unsigned int i, count, l;
unsigned long off_raw, ptr;

rate=RateSB(rate);
printf(" - %u\n",rate);

off_raw=ftell(f);
l=fread(raw,1,len,f);
i=0; ptr=0;
while ( 1 )
{
	if ( (l+ptr)>=len_data )
	{
		l=len_data-ptr;
		fseek(f,off_raw,SEEK_SET);
		ptr=0;
	}
	else	ptr+=l;
	PlaySB(raw,l);
	i++;
	printf("%04u,%06u\r",i,l);
	l=fread(raw,1,len,f);
	while ( StatePlaySB()==0 )
		if ( kbhit() ) { getch(); goto Fin; }
	if ( ptr==0 ) delay(200);
}
Fin:
fseek(f,off_raw,SEEK_SET);
printf("\n");
return i;
}


void	playWave
	( char * name )
{
unsigned int len;
FILE * f;
char far * raw;
TitleWave tw;
TitleDataWave tdw;

f = fopen(name,"rb");
raw = ( char far * ) farmalloc(dBuf.len);
if ( f == 0 || raw==0 )
{
	printf("   䠩 - %s\n",name);
	printf(" \n",name);
	ResetSB();
	return;
}

fread(&tw,sizeof(TitleWave),1,f);
printf("LEN RIFF\t - %ld\n", tw.len_riff );
if ( strncmp(tw.id_riff,"RIFF",4)!=0 )
	{ printf(" ᮢ 䨪 RIFF\n"); goto Fin; }
printf("LEN Chuck\t - %ld\n", tw.len_chuck );
if ( strncmp(tw.id_chuck,"WAVE",4)!=0 )
	{ printf(" ᮢ 䨪 CHUCK\n"); goto Fin; }
if ( strncmp(tw.fmt,"fmt ",4)!=0 )
	{ printf(" ᮢ 䨪 FMT\n"); goto Fin; }
printf("Type\t\t - %d\n", tw.type );
printf("Channels\t - %d\n", tw.channels );
printf("Sample Per Sec\t - %u\n", tw.freq );
printf("Bytes Per Sec\t - %d\n", tw.bytes );
printf("Bits\t\t - %d\n", tw.bits );
printf("Aligned\t\t - %d\n", tw.align );

fseek( f, tw.len_chuck-16, SEEK_CUR);
fread( &tdw, sizeof(TitleDataWave),1, f);
printf("LEN Data\t - %lu\n", tdw.len_data );
if ( strncmp(tdw.id_data,"data",4)!=0 )
	{ printf(" ᮢ 䨪 DATA\n"); goto Fin; }

printf("ந .wav ...\n");

playFile ( f, tw.freq, raw, dBuf.len, tdw.len_data );

Fin:
if ( f!=0 ) fclose(f);
if ( raw!=0 ) farfree(raw);
ResetSB();
}


void	playRaw
	( char * name, int argc, char * txt_rate )
{
FILE * f;
char far * raw;
unsigned int freq;
unsigned long len_data;

f = fopen(name,"rb");
raw = ( char far * ) farmalloc(dBuf.len);
if ( f == 0 || raw==0 )
{
	printf("   䠩 - %s\n",name);
	printf(" \n",name);
	ResetSB();
	return;
}

printf("ந .raw ...\n");

if ( argc>=3 ) freq=atoi(txt_rate);
else freq=11000;

fseek(f,0L,SEEK_END);
len_data=ftell(f);
fseek(f,0L,SEEK_SET);

playFile ( f, freq, raw, dBuf.len, len_data );

if ( f!=0 ) fclose(f);
if ( raw!=0 ) farfree(raw);
ResetSB();

}


void	playVoc
	( char * name )
{
FILE * f;
char far * raw;
VocHeader vh;
VocBlock vb;
VocBlock1 vb1;
VocBlock3 vb3;
VocBlock8 vb8;
unsigned int rate;
char yes8=0;

f = fopen(name,"rb");
raw = ( char far * ) farmalloc(32000L);
if ( f == 0 || raw==0 )
{
	printf("   䠩 - %s\n",name);
	printf(" \n",name);
	ResetSB();
	return;
}

fread(&vh,sizeof(VocHeader),1,f);
if ( strncmp(vh.txt_id,"Creative Voice File\x1a",19)!=0 )
	{ printf(" \n"); goto Fin; }
printf("Creative Voice File\t - v%u.%02u\n",(vh.ver>>8)&0xFF,vh.ver&0xFF);
printf("砫\t\t\t - %Xh\n",vh.offset_data);
printf("䨪\t\t - %Xh\n",vh.id);
if((((~vh.ver)+0x1234)&0xFFFF)!=vh.id)
	{ printf(" ᮢ\n"); goto Fin; }

fseek( f, vh.offset_data, SEEK_SET );
while(1)
{
	fread(&vb,sizeof(VocBlock)-1,1,f);
	vb.len&=0xffffffL; //   
	if ( ferror(f)!=0 )
		{ printf("訡 ⥭\n"); goto Fin; }
	switch ( vb.type )
	{
	case 0: printf(".\n"); goto Fin;
	case 1: printf(" :");
		fread(&vb1,sizeof(VocBlock1),1,f);
		if ( yes8==0 )
		    rate = (unsigned int)(1000000/(256-vb1.rate));
		printf("  - %u, 㯠 - %u, len - %lu\n",
		 rate, vb1.type_zip, vb.len-2 );
		playFile ( f, rate, raw, dBuf.len, vb.len-2 );
		fseek( f, vb.len-2, SEEK_CUR );
		break;
	case 2: printf("த 㪠 : - %lu\n", vb.len );
		playFile ( f, rate, raw, dBuf.len, vb.len );
		fseek( f, vb.len, SEEK_CUR );
		break;
        case 3:
                fread(&vb3,sizeof(VocBlock3),1,f);
                printf("設 : ६ - %u,  - %u\n",
                        vb3.time, vb3.rate );
                break;
        case 4:
                fread(&marker,2,1,f);
                printf("થ - %u\n", marker );
                break;
        case 5:
                printf("  - %lu\n",vb.len);
		fseek( f, vb.len, SEEK_CUR );
		break;
        case 6:
                fread( &count_repeat,2,1,f );
                printf("७ - %u\n", count_repeat-1);
                break;
        case 7:
                printf(" ७\n");
                break;
        case 8:
                fread(&vb8,sizeof(VocBlock8),1,f);
                rate = (unsigned int)(256000000L/(65536L-vb8.rate));
		yes8=1;
                printf("ன :  - %u, 㯠 - %u, ० - %s\n",
                        rate, vb8.pack, vb8.mode==0?"":"८" );
                break;
        default:
		printf("T - %u ??????\n", vb.type );
		fseek( f, vb.len, SEEK_CUR );
		break;
	}
}

Fin:
if ( f!=0 ) fclose(f);
if ( raw!=0 ) farfree(raw);
ResetSB();
}


void    main
	( int argc, char * argv[] )
{
char drive[MAXDRIVE];
char dir[MAXDIR];
char file[MAXFILE];
char ext[MAXEXT];
InitSB isb;

if ( argc<2 )
{
	printf("  䠩 .wav, .voc\n");
	return;
}

if ( sbEnvData(&isb)==0 )
	printf(" 窨 BLASTER  㦥 !!!\n");
else	printf("BLASTER = A%X, I%d, D%d, T%d\n",
	       isb.port, isb.irq, isb.dma, isb.ver );
if ( SetupSB(isb.irq,isb.dma)!=1 )
{
	printf("No Sound Blaster\n");
	return;
}

fnsplit(argv[1],drive,dir,file,ext);
if ( strcmpi(ext,".wav")==0 )
	playWave(argv[1]);
else
{
if ( strcmpi(ext,".voc")==0 )
	playVoc(argv[1]);
else	playRaw(argv[1],argc,argv[2]);
}

printf("\n");

}

